import { TranslationKeys, OptionsType, OptionsDictionary, OptionsL33tTable, OptionsGraph, RankedDictionaries, Matchers, Matcher, UserInputsOptions, TimeEstimationValues } from './types';
import TrieNode from './matcher/dictionary/variants/matching/unmunger/TrieNode';
export default class Options {
    matchers: Matchers;
    l33tTable: OptionsL33tTable;
    trieNodeRoot: TrieNode;
    dictionary: OptionsDictionary;
    rankedDictionaries: RankedDictionaries;
    rankedDictionariesMaxWordSize: Record<string, number>;
    translations: TranslationKeys;
    graphs: OptionsGraph;
    useLevenshteinDistance: boolean;
    levenshteinThreshold: number;
    l33tMaxSubstitutions: number;
    maxLength: number;
    timeEstimationValues: TimeEstimationValues;
    constructor(options?: OptionsType, customMatchers?: Record<string, Matcher>);
    private setOptions;
    private setTranslations;
    private checkCustomTranslations;
    private setRankedDictionaries;
    private getRankedDictionariesMaxWordSize;
    private buildSanitizedRankedDictionary;
    getUserInputsOptions(dictionary?: (string | number)[]): UserInputsOptions;
    private addMatcher;
}
