/*
 * -------------------------------------------------------------------------------
 *  Dictionary reverse matching --------------------------------------------------
 * -------------------------------------------------------------------------------
 */
class MatchReverse {
  constructor(options, defaultMatch) {
    this.options = options;
    this.defaultMatch = defaultMatch;
  }
  match(matchOptions) {
    const passwordReversed = matchOptions.password.split('').reverse().join('');
    return this.defaultMatch({
      ...matchOptions,
      password: passwordReversed
    }).map(match => ({
      ...match,
      token: match.token.split('').reverse().join(''),
      // reverse back
      reversed: true,
      // map coordinates back to original string
      i: matchOptions.password.length - 1 - match.j,
      j: matchOptions.password.length - 1 - match.i
    }));
  }
}

export { MatchReverse as default };
//# sourceMappingURL=reverse.esm.js.map
