import { REGEXEN } from '../../data/const.esm.js';
import { sorted } from '../../utils/helper.esm.js';

/*
 * -------------------------------------------------------------------------------
 *  regex matching ---------------------------------------------------------------
 * -------------------------------------------------------------------------------
 */
class MatchRegex {
  constructor(options) {
    this.options = options;
  }
  match({
    password
  }) {
    const matches = [];
    Object.keys(REGEXEN).forEach(name => {
      const regex = REGEXEN[name];
      regex.lastIndex = 0; // keeps regexMatch stateless
      let regexMatch;
      // eslint-disable-next-line no-cond-assign
      while (regexMatch = regex.exec(password)) {
        if (regexMatch) {
          const token = regexMatch[0];
          matches.push({
            pattern: 'regex',
            token,
            i: regexMatch.index,
            j: regexMatch.index + regexMatch[0].length - 1,
            regexName: name,
            regexMatch
          });
        }
      }
    });
    return sorted(matches);
  }
}

export { MatchRegex as default };
//# sourceMappingURL=matching.esm.js.map
