'use strict';

var mergeUserInputDictionary = ((optionsRankedDictionaries, optionsRankedDictionariesMaxWordSize, userInputsOptions) => {
  const rankedDictionaries = {
    ...optionsRankedDictionaries
  };
  const rankedDictionariesMaxWordSize = {
    ...optionsRankedDictionariesMaxWordSize
  };
  if (!userInputsOptions) {
    return {
      rankedDictionaries,
      rankedDictionariesMaxWordSize
    };
  }
  rankedDictionaries.userInputs = {
    ...(rankedDictionaries.userInputs || {}),
    ...userInputsOptions.rankedDictionary
  };
  rankedDictionariesMaxWordSize.userInputs = Math.max(userInputsOptions.rankedDictionaryMaxWordSize, rankedDictionariesMaxWordSize.userInputs || 0);
  return {
    rankedDictionaries,
    rankedDictionariesMaxWordSize
  };
});

module.exports = mergeUserInputDictionary;
//# sourceMappingURL=mergeUserInputDictionary.js.map
